{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        init : function(){
            var t = this;
            var refreshInterval = 60;
            {{ modulename }}Obj.superclass.init.call(t);
            t.recordsperpage=10000;
            t.windowButtons.add=false;
            t.windowButtons.edit=false;
            var routeName = t.modulename + '-showall';
            var route = Routing.getRoute(routeName);
			var data = {
				'pg': 1,
				'lm': t.recordsperpage
			};
			var url = Routing.generate(routeName, data);
            t.stores.main.url=url;
            const gridConfig = {
                pbar: new mj.pager({
                    pos: 'bottom',
                    beforePageText: false,
                    limit: t.recordsperpage,
                    defaultButtons:false,
                    elements:{
                        selectLimit:false
                    }
                }),
                cm: [
                    {header: "{{ 'WatchEmployee.employee'|trans }}", dataIndex: 'name', width: 200,filter:'single',alias:'e',operator:'%.%'},
                    {header: "{{ 'WatchEmployee.time'|trans }}", dataIndex: 'sure', width: 80,alias:'e'},
                    {header: "{{ 'WatchEmployee.work'|trans }}", dataIndex: 'worktime', width: 80,alias:'e'},
                    {header: "{{ 'WatchEmployee.lost'|trans }}", dataIndex: 'work_lost', width: 80,alias:'e'},
                    {header: "{{ 'WatchEmployee.timeprod'|trans }}", dataIndex: 'timeprod', width: 80,alias:'e'},
                    {header: "{{ 'WatchEmployee.timenotwork'|trans }}", dataIndex: 'out_lost', width: 80,alias:'e'},
                    {header: "{{ 'WatchEmployee.timeout'|trans }}", dataIndex: 'isout', width: 60,renderer:mj.renderer.check(),alias:'e'},
                    {header: "{{ 'WatchEmployee.lastprod'|trans }}", dataIndex: 'lastprod', width: 150,alias:'e'},
                    {header: "{{ 'WatchEmployee.client'|trans }}", dataIndex: 'lastclient', width: 80,alias:'e'},
                    {header: "{{ 'WatchEmployee.timelast'|trans }}", dataIndex: 'lasttime', width: 100,alias:'e'}
                ]
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    })
                ]
            };
            t._setFormConfig(formConfig);
            t._Timer = false;
            t.grids.main.store.on("load",function(){
                if(t._Timer)
                    clearTimeout(t._Timer);
                t._Timer = setTimeout(function(){t.grids.main.load();},refreshInterval*1000);
            });

            t.grids.main.on('afterload', function(){
                for(var i=0;i<this.rows.length;i++){
                    var item=this.rows[i];
                    if(item.data.rowColor!='')
                        item.el[0].style.background=item.data.rowColor;
                }
            });
                
            t.win.on('beforeclose', function(){clearTimeout(t._Timer);});
        },
        deleteRecord: function() {
            var t = this,
                _f = this.forms;
            var selectedRecord = t.getSelectedRecord();
            if (selectedRecord !== false) {
                mj.message({
                    title: mj.lng.glb.winTitleOnay,
                    modal : true,
                    msg: "{{ 'WatchEmployee.employeekickquestion'|trans }}",
                    buttons:['NO','YES'],
                    cb:function(el,btn){
                        if(btn=='YES'){
                            var id = selectedRecord.id;
                            var version = selectedRecord.version;
                            var routeName = t.modulename + '-del';
                            var route = Routing.getRoute(routeName);
                            var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                                'pg': t.grids.main.pbar.current,
                                'lm': t.grids.main.pbar.limit
                            } : {};
                            var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                                'id': id,
                                'v': version
                            }) : pagerParams);
                            if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                                t.waitMaskShow();
                                t._event='delete';
                                var data = {'menuId': t.id};
                                $.ajax({
                                    url: url,
                                    method: "POST",
                                    headers: { 
                                        "Content-Type": "application/json",
                                        "X-HTTP-Method-Override": route.methods[0] 
                                    },
                                    dataType: 'json',
                                    data: JSON.stringify(data),
                                    success: function(data, textStatus, jqXHR) {
                                        t.reset(_f, data);
                                    },
                                    error: function(jqXHR, textStatus, errorThrown) {
                                        t.waitMaskHide();
                                        mj.message({
                                            title: mj.lng.glb.error,
                                            msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                            type: "error",
                                            html: true
                                        });
                                    },
                                    complete: function(jqXHR, textStatus) {
                                        //t.waitMaskHide();
                                    }
                                });
                            }
                        }
                        el.window.close();
                    }
                });
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
